const Util           = imports.misc.util;
const MessageTray    = imports.ui.main.messageTray;
const Monitor        = imports.ui.main.layoutManager.bottomMonitor;
const PointerWatcher = imports.ui.pointerWatcher.getPointerWatcher();
const Me             = imports.misc.extensionUtils.getCurrentExtension();

const Settings = Me.imports.convenience.getSettings();

let orig   = {};
let custom = {};

function init() {
    orig = PointerWatcher._watches[0];
}

function enable() {
    PointerWatcher._removeWatch(orig);

    custom = PointerWatcher.addWatch(100 /*ms*/, function(x, y) {
        if (x == Monitor.x &&
            y == Monitor.y + Monitor.height - 1 &&
            Settings.get_boolean('enabled')) {
            Util.spawnCommandLine(Settings.get_string('command'));
        }
        if (x == Monitor.x + Monitor.width - 1 &&
            y == Monitor.y + Monitor.height - 1) {
            MessageTray.toggle();
        }        
    });
}

function disable() {
    PointerWatcher._removeWatch(custom);
    orig = PointerWatcher.addWatch(orig.interval, orig.callback);
}
